/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.api.render;

import net.fabricmc.fabric.api.event.Event;
import net.fabricmc.fabric.api.event.EventFactory;
import net.minecraft.class_1047;
import net.minecraft.class_1058;
import net.minecraft.class_1059;
import net.minecraft.class_2960;
import net.minecraft.class_4730;

@FunctionalInterface
public interface PartStaticModelRegisterEvent {

    Event<PartStaticModelRegisterEvent> EVENT
        = EventFactory.createArrayBacked(PartStaticModelRegisterEvent.class, (listeners) -> (renderer) -> {
            for (PartStaticModelRegisterEvent l : listeners) {
                l.registerModels(renderer);
            }
        });

    void registerModels(StaticModelRenderer renderer);

    public interface StaticModelRenderer {
        <K extends PartModelKey> void register(Class<K> clazz, PartModelBaker<K> renderer);

        // Sprites

        default class_1058 getMissingBlockSprite() {
            return getSprite(class_1059.field_5275, class_1047.method_4539());
        }

        default class_1058 getBlockSprite(String id) {
            return getSprite(class_1059.field_5275, new class_2960(id));
        }

        default class_1058 getBlockSprite(class_2960 id) {
            return getSprite(class_1059.field_5275, id);
        }

        class_1058 getSprite(class_2960 atlasId, class_2960 spriteId);

        default class_1058 getSprite(class_4730 spriteId) {
            return getSprite(spriteId.method_24144(), spriteId.method_24147());
        }
    }
}
