/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.impl;

import java.util.function.Consumer;

import alexiil.mc.lib.multipart.impl.client.render.MultipartOutlineRenderer;
import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.fabric.api.blockrenderlayer.v1.BlockRenderLayerMap;
import net.fabricmc.fabric.api.client.model.ModelLoadingRegistry;
import net.fabricmc.fabric.api.client.model.ModelProviderContext;
import net.fabricmc.fabric.api.client.model.ModelProviderException;
import net.fabricmc.fabric.api.client.model.ModelVariantProvider;
import net.fabricmc.fabric.api.client.rendereregistry.v1.BlockEntityRendererRegistry;

import net.fabricmc.fabric.api.client.rendering.v1.WorldRenderEvents;
import net.minecraft.class_1091;
import net.minecraft.class_1100;
import net.minecraft.class_1921;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_3300;
import alexiil.mc.lib.multipart.impl.client.model.MultipartModel;
import alexiil.mc.lib.multipart.impl.client.render.MultipartBlockEntityRenderer;

public class LibMultiPartClient implements ClientModInitializer {

    public static final class_1091 MODEL_IDENTIFIER
        = new class_1091(new class_2960(LibMultiPart.NAMESPACE, "container"), "");

    @Override
    public void onInitializeClient() {
        LibMultiPart.isWorldClientPredicate = w -> w != null && w == class_310.method_1551().field_1687;
        LibMultiPart.partialTickGetter = class_310.method_1551()::method_1488;
        ModelLoadingRegistry.INSTANCE.registerVariantProvider(res -> varProvider());
        ModelLoadingRegistry.INSTANCE.registerModelProvider(LibMultiPartClient::requestModels);
        BlockRenderLayerMap.INSTANCE.putBlock(LibMultiPart.BLOCK, class_1921.method_23581());
        BlockEntityRendererRegistry.INSTANCE.register(LibMultiPart.BLOCK_ENTITY, MultipartBlockEntityRenderer::new);
        WorldRenderEvents.BLOCK_OUTLINE.register(MultipartOutlineRenderer.INSTANCE);
    }

    private static ModelVariantProvider varProvider() {
        return new ModelVariantProvider() {

            MultipartModel.Unbaked ubaked = null;

            @Override
            public class_1100 loadModelVariant(class_1091 modelId, ModelProviderContext context)
                throws ModelProviderException {

                if (modelId.method_12836().equals(MODEL_IDENTIFIER.method_12836())) {
                    if (modelId.method_12832().equals(MODEL_IDENTIFIER.method_12832())) {
                        return ubaked == null ? (ubaked = new MultipartModel.Unbaked()) : ubaked;
                    }
                }
                return null;
            }
        };
    }

    private static void requestModels(class_3300 res, Consumer<class_2960> out) {
        out.accept(MODEL_IDENTIFIER);
    }
}
