/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.impl;

import java.util.function.Function;
import net.minecraft.class_2487;
import net.minecraft.class_259;
import net.minecraft.class_265;
import net.minecraft.class_2960;
import alexiil.mc.lib.multipart.api.MissingPart;
import alexiil.mc.lib.multipart.api.MissingPartDefinition;
import alexiil.mc.lib.multipart.api.MultipartHolder;
import alexiil.mc.lib.multipart.api.render.PartModelKey;

public final class MissingPartImpl extends MissingPart {

    private static final Function<Object[], MissingPartDefinition> MISSING_PART_DEF_CTOR
        = LmpReflection.getApiConstructor(MissingPartDefinition.class, class_2960.class);

    static final MissingPartDefinition DEF_NOT_AN_ID
        = MISSING_PART_DEF_CTOR.apply(new Object[] { new class_2960("libmultipart", "unknown/not_an_id") });

    final String originalId;
    final class_2487 originalNbt;

    MissingPartImpl(MultipartHolder holder, String originalId, class_2487 originalNbt) {
        super(createDefinition(originalId), holder);
        this.originalId = originalId;
        this.originalNbt = originalNbt;
    }

    private static MissingPartDefinition createDefinition(String originalId) {
        class_2960 id = class_2960.method_12829(originalId);
        if (id != null) {
            return MISSING_PART_DEF_CTOR.apply(new Object[] { id });
        } else {
            return DEF_NOT_AN_ID;
        }
    }

    @Override
    public class_265 getShape() {
        return class_259.method_1073();
    }

    @Override
    public PartModelKey getModelKey() {
        // TODO: If we have a shape then emit with this!
        return null;
    }
}
