/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.impl;

import java.util.List;
import java.util.Random;

import javax.annotation.Nullable;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.rendering.data.v1.RenderAttachedBlockView;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1439;
import net.minecraft.class_1542;
import net.minecraft.class_1657;
import net.minecraft.class_173;
import net.minecraft.class_1799;
import net.minecraft.class_181;
import net.minecraft.class_1922;
import net.minecraft.class_1928;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_1959;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2343;
import net.minecraft.class_2350;
import net.minecraft.class_2371;
import net.minecraft.class_238;
import net.minecraft.class_239;
import net.minecraft.class_2415;
import net.minecraft.class_243;
import net.minecraft.class_2470;
import net.minecraft.class_2586;
import net.minecraft.class_259;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_2758;
import net.minecraft.class_310;
import net.minecraft.class_3218;
import net.minecraft.class_3610;
import net.minecraft.class_3611;
import net.minecraft.class_3612;
import net.minecraft.class_3726;
import net.minecraft.class_3737;
import net.minecraft.class_3965;
import net.minecraft.class_47;
import net.minecraft.class_5558;
import alexiil.mc.lib.multipart.api.AbstractPart;
import alexiil.mc.lib.multipart.api.AbstractPart.ItemDropTarget;
import alexiil.mc.lib.multipart.api.PartLootParams;
import alexiil.mc.lib.multipart.api.SubdividedPart;
import alexiil.mc.lib.multipart.api.event.PartEventEntityCollide;
import alexiil.mc.lib.multipart.api.event.PartPrecipitationTickEvent;
import alexiil.mc.lib.multipart.api.event.PartRandomDisplayTickEvent;
import alexiil.mc.lib.multipart.api.event.PartRandomTickEvent;
import alexiil.mc.lib.multipart.api.event.PartScheduledTickEvent;
import alexiil.mc.lib.multipart.api.property.MultipartProperties;
import alexiil.mc.lib.multipart.impl.TransientPartIdentifier.IdAdditional;
import alexiil.mc.lib.multipart.impl.TransientPartIdentifier.IdSubPart;
import alexiil.mc.lib.multipart.impl.client.PartModelData;
import alexiil.mc.lib.multipart.mixin.api.IBlockCustomParticles;
import alexiil.mc.lib.multipart.mixin.api.IBlockDynamicCull;
import alexiil.mc.lib.multipart.mixin.api.IBlockMultipart;

public class MultipartBlock extends class_2248
    implements class_2343, IBlockMultipart<TransientPartIdentifier>, class_3737, IBlockDynamicCull,
    IBlockCustomParticles {

    public static final class_2758 LUMINANCE = class_2758.method_11867("luminance", 0, 15);
    public static final class_2746 EMITS_REDSTONE = class_2746.method_11825("emits_redstone");

    public MultipartBlock(class_2251 settings) {
        super(settings);
        method_9590(
            method_9564()//
                .method_11657(LUMINANCE, 0)//
                .method_11657(EMITS_REDSTONE, false)//
                .method_11657(class_2741.field_12508, false)//
        );
    }

    // ###############
    //
    // Misc
    //
    // ###############

    @Override
    protected void method_9515(class_2689.class_2690<class_2248, class_2680> builder) {
        super.method_9515(builder);
        builder.method_11667(LUMINANCE, EMITS_REDSTONE, class_2741.field_12508);
    }

    @Override
    public class_2586 method_10123(class_2338 pos, class_2680 state) {
        return new MultipartBlockEntity(pos, state);
    }

    @Override
    public <T extends class_2586> class_5558<T> method_31645(
        class_1937 world, class_2680 state, class_2591<T> type
    ) {
        return type == LibMultiPart.BLOCK_ENTITY ? (w, p, s, be) -> ((MultipartBlockEntity) be).tick() : null;
    }

    @Override
    public class_2680 method_9598(class_2680 state, class_2470 rotation) {
        // This is really just a TODO for the block entity.rotate method
        throw new UnsupportedOperationException("Need BlockEntity.rotate too pls mojang");
    }

    @Override
    public class_2680 method_9569(class_2680 state, class_2415 mirror) {
        // This is really just a TODO for the block entity.mirror method
        throw new UnsupportedOperationException("Need BlockEntity.mirror too pls mojang");
    }

    @Override
    public class_265 method_9549(class_2680 state, class_1922 view, class_2338 pos, class_3726 ctx) {
        if (view instanceof RenderAttachedBlockView renderView) {
            Object data = renderView.getBlockEntityRenderAttachment(pos);
            if (data instanceof PartModelData partData) {
                return partData.collisionShape;
            }
        }

        if (view.method_8321(pos) instanceof MultipartBlockEntity container) {
            return container.container.getCollisionShape();
        }
        return class_259.method_1073();
    }

    @Override
    public class_265 method_9530(class_2680 state, class_1922 view, class_2338 pos, class_3726 ctx) {
        if (view instanceof RenderAttachedBlockView renderView) {
            Object data = renderView.getBlockEntityRenderAttachment(pos);
            if (data instanceof PartModelData partData) {
                return partData.outlineShape;
            }
        }

        if (view.method_8321(pos) instanceof MultipartBlockEntity container) {
            return container.container.getOutlineShape();
        }
        return class_259.method_1073();
    }

    @Override
    public class_265 method_9571(class_2680 state, class_1922 view, class_2338 pos) {
        if (view instanceof RenderAttachedBlockView renderView) {
            Object data = renderView.getBlockEntityRenderAttachment(pos);
            if (data instanceof PartModelData partData) {
                return partData.cullingShape;
            }
        }

        if (view.method_8321(pos) instanceof MultipartBlockEntity container) {
            return container.container.getCullingShape();
        }
        return super.method_9571(state, view, pos);
    }

    @Override
    public boolean hasDynamicCull(class_2680 state) {
        return true;
    }

    @Override
    public void method_9536(class_2680 oldState, class_1937 world, class_2338 pos, class_2680 newState, boolean bool) {
        class_2586 be = world.method_8321(pos);
        if (be instanceof MultipartBlockEntity) {
            MultipartBlockEntity container = (MultipartBlockEntity) be;
            container.onRemoved();
        }
        super.method_9536(oldState, world, pos, newState, bool);
    }

    @Override
    public void method_9612(
        class_2680 state, class_1937 world, class_2338 thisPos, class_2248 otherBlock, class_2338 otherPos, boolean unknownBoolean
    ) {
        super.method_9612(state, world, thisPos, otherBlock, otherPos, unknownBoolean);
        class_2586 be = world.method_8321(thisPos);
        if (be instanceof MultipartBlockEntity) {
            MultipartBlockEntity container = (MultipartBlockEntity) be;
            container.onNeighbourUpdate(otherPos);
        }
    }

    @Override
    public class_2680 method_9559(
        class_2680 state, class_2350 direction, class_2680 neighborState, class_1936 world, class_2338 pos,
        class_2338 neighborPos
    ) {
        class_2586 be = world.method_8321(pos);
        if (be instanceof MultipartBlockEntity) {
            MultipartBlockEntity container = (MultipartBlockEntity) be;
            container.onNeighbourStateUpdate(direction, neighborPos, neighborState);
        }
        return super.method_9559(state, direction, neighborState, world, pos, neighborPos);
    }

    @Override
    public class_1269 method_9534(
        class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand, class_3965 hit
    ) {
        class_1269 handled = super.method_9534(state, world, pos, player, hand, hit);
        TransientPartIdentifier target = getMultipartTarget(state, world, pos, hit.method_17784());
        if (target != null) {
            handled = target.part.onUse(player, hand, hit);
        }
        return handled;
    }

    @Override
    public void method_9548(class_2680 state, class_1937 world, class_2338 pos, class_1297 entity) {
        super.method_9548(state, world, pos, entity);
        class_2586 be = world.method_8321(pos);
        if (be instanceof MultipartBlockEntity) {
            MultipartBlockEntity container = (MultipartBlockEntity) be;
            container.container.fireEvent(new PartEventEntityCollide(entity));
        }
    }

    @Override
    @Environment(EnvType.CLIENT)
    public class_1799 method_9574(class_1922 view, class_2338 pos, class_2680 state) {
        class_310 mc = class_310.method_1551();
        class_239 hit = mc.field_1765;
        if (view != null && view == mc.field_1687 && hit != null && hit.method_17783() == class_239.class_240.field_1332) {
            TransientPartIdentifier target = getMultipartTarget(state, view, pos, hit.method_17784());
            if (target != null) {
                return target.part.getPickStack((class_3965) hit);
            }
        }
        return class_1799.field_8037;
    }

    @Override
    public void method_9514(class_2680 state, class_3218 world, class_2338 pos, Random random) {
        class_2586 be = world.method_8321(pos);
        if (be instanceof MultipartBlockEntity container) {
            container.container.fireEvent(PartRandomTickEvent.INSTANCE);
        }
    }

    @Override
    public void method_9588(class_2680 state, class_3218 world, class_2338 pos, Random random) {
        class_2586 be = world.method_8321(pos);
        if (be instanceof MultipartBlockEntity container) {
            container.container.fireEvent(PartScheduledTickEvent.INSTANCE);
        }
    }

    @Override
    public void method_9496(class_2680 state, class_1937 world, class_2338 pos, Random random) {
        class_2586 be = world.method_8321(pos);
        if (be instanceof MultipartBlockEntity container) {
            container.container.fireEvent(PartRandomDisplayTickEvent.INSTANCE);
        }
    }

    @Override
    public void method_9504(class_2680 state, class_1937 world, class_2338 pos, class_1959.class_1963 precipitation) {
        class_2586 be = world.method_8321(pos);
        if (be instanceof MultipartBlockEntity container) {
            container.container.fireEvent(new PartPrecipitationTickEvent(precipitation));
        }
    }

    // ###############
    //
    // Redstone
    //
    // ###############

    @Override
    public boolean method_9506(class_2680 state) {
        return state.method_11654(EMITS_REDSTONE);
    }

    @Override
    public int method_9603(class_2680 state, class_1922 view, class_2338 pos, class_2350 oppositeFace) {
        class_2586 be = view.method_8321(pos);
        if (be instanceof MultipartBlockEntity multiBE) {
            return multiBE.container.getStrongRedstonePower(oppositeFace.method_10153());
        }
        return 0;
    }

    @Override
    public int method_9524(class_2680 state, class_1922 view, class_2338 pos, class_2350 oppositeFace) {
        class_2586 be = view.method_8321(pos);
        if (be instanceof MultipartBlockEntity multiBE) {
            return multiBE.container.getWeakRedstonePower(oppositeFace.method_10153());
        }
        return 0;
    }

    // ###############
    //
    // Waterloggable
    //
    // ###############

    @Override
    public boolean method_10310(class_1922 view, class_2338 pos, class_2680 state, class_3611 fluid) {
        if (fluid != class_3612.field_15910) {
            return false;
        }
        class_2586 be = view.method_8321(pos);
        if (be instanceof MultipartBlockEntity) {
            return ((MultipartBlockEntity) be).container.properties.getValue(MultipartProperties.CAN_BE_WATERLOGGED);
        }
        return true;
    }

    @Override
    public boolean method_10311(class_1936 world, class_2338 pos, class_2680 state, class_3610 fluid) {
        if (!method_10310(world, pos, state, fluid.method_15772())) {
            return false;
        }
        return class_3737.super.method_10311(world, pos, state, fluid);
    }

    @Override
    public class_3610 method_9545(class_2680 state) {
        return state.method_11654(class_2741.field_12508) ? class_3612.field_15910.method_15729(false) : super.method_9545(state);
    }

    // ###############
    //
    // IBlockCustomParticles
    //
    // ###############

    @Override
    @Environment(EnvType.CLIENT)
    public boolean spawnBreakingParticles(class_1937 world, class_2338 pos, class_2680 state, class_2350 side, class_243 hitVec) {
        TransientPartIdentifier target = getMultipartTarget(state, world, pos, hitVec);
        if (target != null) {

            if (target.extra instanceof IdSubPart<?>) {
                if (spawnSubBreakingParticles(hitVec, side, (IdSubPart<?>) target.extra)) {
                    return true;
                }
            } else if (target.extra instanceof IdAdditional) {
                for (AbstractPart extra : ((IdAdditional) target.extra).additional) {
                    extra.spawnHitParticle(side);
                }
            }

            return target.part.spawnHitParticle(side);
        }
        return false;
    }

    private static <Sub> boolean spawnSubBreakingParticles(class_243 hitVec, class_2350 side, IdSubPart<Sub> extra) {
        return extra.part.spawnBreakingParticles(hitVec, extra.subpart, side);
    }

    @Override
    @Environment(EnvType.CLIENT)
    public boolean spawnSprintingParticles(class_1937 world, class_2338 pos, class_2680 state, class_1297 sprintingEntity,
                                           Random entityRandom) {
        // Clearance always seems to be 0.2 for these entity-collision particles
        TransientPartIdentifier colliding =
                getMultipartColliding(state, world, pos, sprintingEntity.method_5829(), 0.2);
        if (colliding != null) {
            return colliding.part.spawnSprintParticle(sprintingEntity, entityRandom);
        }

        // You pretty much always want to return true here, regardless of whether particles were actually spawned,
        // because returning true prevents the missing-texture particles from being spawned.
        return true;
    }

    @Override
    @Environment(EnvType.CLIENT)
    public boolean spawnIronGolemParticles(class_1937 world, class_2338 pos, class_2680 state, class_1439 ironGolem,
                                           Random entityRandom) {
        // Clearance always seems to be 0.2 for these entity-collision particles
        TransientPartIdentifier colliding =
                getMultipartColliding(state, world, pos, ironGolem.method_5829(), 0.2);
        if (colliding != null) {
            return colliding.part.spawnIronGolemParticle(ironGolem, entityRandom);
        }

        // You pretty much always want to return true here, regardless of whether particles were actually spawned,
        // because returning true prevents the missing-texture particles from being spawned.
        return true;
    }

    @Override
    public boolean spawnFallParticles(class_3218 world, class_2338 pos, class_2680 state, class_1309 fallenEntity,
                                      Random entityRandom) {
        // Clearance always seems to be 0.2 for these entity-collision particles
        TransientPartIdentifier colliding =
                getMultipartColliding(state, world, pos, fallenEntity.method_5829(), 0.2);
        if (colliding != null) {
            return colliding.part.onSpawnFallParticles(fallenEntity, entityRandom);
        }

        // You pretty much always want to return true here, regardless of whether particles were actually spawned,
        // because returning true prevents the missing-texture particles from being spawned.
        return true;
    }

    // ###############
    //
    // IBlockMultipart
    //
    // ###############

    @Override
    public Class<TransientPartIdentifier> getKeyClass() {
        return TransientPartIdentifier.class;
    }

    @Override
    public void onBlockBreakStart(
        class_2680 state, class_1937 world, class_2338 pos, class_1657 player, TransientPartIdentifier subpart
    ) {
        method_9606(state, world, pos, player);
    }

    @Override
    public float calcBlockBreakingDelta(
        class_2680 state, class_1657 player, class_1922 view, class_2338 pos, TransientPartIdentifier subpart
    ) {
        return subpart.part.calculateBreakingDelta(player);
    }

    @Override
    public void onBreak(
        class_1937 world, class_2338 pos, class_2680 state, class_1657 player, TransientPartIdentifier subpart
    ) {
        if (subpart.extra instanceof IdSubPart<?>) {
            if (onSubpartBreak(player, (IdSubPart<?>) subpart.extra)) {
                return;
            }
        } else if (subpart.extra instanceof IdAdditional) {
            for (AbstractPart part : ((IdAdditional) subpart.extra).additional) {
                part.onBreak(player);
            }
        }
        if (!subpart.part.onBreak(player)) {
            method_9576(world, pos, state, player);
        }
    }

    private static <Sub> boolean onSubpartBreak(class_1657 player, IdSubPart<Sub> extra) {
        return extra.part.onSubpartBreak(player, extra.subpart);
    }

    @Override
    public boolean clearBlockState(class_1937 world, class_2338 pos, TransientPartIdentifier subpart) {
        if (subpart.extra instanceof IdSubPart<?>) {
            return clearSubPart((IdSubPart<?>) subpart.extra);
        }

        class_2586 be = world.method_8321(pos);
        if (be instanceof MultipartBlockEntity) {
            MultipartBlockEntity multi = (MultipartBlockEntity) be;
            return multi.container.removePart(subpart.part);
        }
        return world.method_8650(pos, false);
    }

    private static <Sub> boolean clearSubPart(IdSubPart<Sub> extra) {
        return extra.part.clearSubpart(extra.subpart);
    }

    @Override
    public void onBroken(class_1936 world, class_2338 pos, class_2680 state, TransientPartIdentifier subpart) {
        method_9585(world, pos, state);
    }

    @Override
    public void afterBreak(
        class_1937 world, class_1657 player, class_2338 pos, class_2680 state, class_2586 blockEntity, class_1799 stack,
        TransientPartIdentifier subpart
    ) {
        if (subpart.extra instanceof IdSubPart<?>) {
            afterSubpartBreak(player, stack, (IdSubPart<?>) subpart.extra);
        } else {
            if (world instanceof class_3218 sv) {
                class_47.class_48 ctxBuilder = new class_47.class_48(sv);
                ctxBuilder.method_311(world.field_9229);
                ctxBuilder.method_312(class_181.field_1224, state);
                ctxBuilder.method_312(class_181.field_24424, class_243.method_24953(pos));
                ctxBuilder.method_312(class_181.field_1229, stack);
                ctxBuilder.method_306(class_181.field_1226, player);
                ctxBuilder.method_306(class_181.field_1228, blockEntity);
                subpart.putLootContext(ctxBuilder);
                class_47 context = ctxBuilder.method_309(PartLootParams.PART_TYPE);
                subpart.part.afterBreak(player);
                subpart.part.addDrops(createDropTarget(subpart.part), context);
                for (AbstractPart part : ((IdAdditional) subpart.extra).additional) {
                    part.afterBreak(player);
                    part.addDrops(createDropTarget(part), context);
                }
            } else {
                subpart.part.afterBreak(player);
                for (AbstractPart part : ((IdAdditional) subpart.extra).additional) {
                    part.afterBreak(player);
                }
            }
        }
    }

    private static <Sub> void afterSubpartBreak(class_1657 player, class_1799 tool, IdSubPart<Sub> extra) {
        extra.part.afterSubpartBreak(player, tool, extra.subpart);
    }

    static ItemDropTarget createDropTarget(AbstractPart part) {
        return new ItemDropTarget() {

            final boolean canDrop
                = part.holder.getContainer().getMultipartWorld().method_8450().method_8355(class_1928.field_19392);

            class_243 center = null;

            @Override
            public boolean dropsAsEntity() {
                return true;
            }

            @Override
            public void drop(class_1799 stack) {
                if (!canDrop) {
                    return;
                }

                if (center == null) {
                    center = part.getOutlineShape().method_1107().method_1005();
                    center = center.method_1019(class_243.method_24954(part.holder.getContainer().getMultipartPos()));
                }
                drop(stack, center);
            }

            @Override
            public void drop(class_1799 stack, class_243 pos) {
                if (!canDrop) {
                    return;
                }

                class_1937 world = part.holder.getContainer().getMultipartWorld();
                while (!stack.method_7960()) {
                    class_1799 split = stack.method_7971(world.field_9229.nextInt(21) + 10);
                    class_1542 ent = new class_1542(world, pos.field_1352, pos.field_1351, pos.field_1350, split);
                    ent.method_6988();
                    ent.method_18800(
                        world.field_9229.nextGaussian() * 0.05, //
                        world.field_9229.nextGaussian() * 0.05 + 0.2, //
                        world.field_9229.nextGaussian() * 0.05//
                    );
                    world.method_8649(ent);
                }
            }

            @Override
            public void drop(class_1799 stack, class_243 pos, class_243 velocity) {
                if (!canDrop) {
                    return;
                }

                class_1937 world = part.holder.getContainer().getMultipartWorld();
                class_1542 ent = new class_1542(world, pos.field_1352, pos.field_1351, pos.field_1350, stack);
                ent.method_18799(velocity);
                ent.method_6988();
                world.method_8649(ent);
            }
        };
    }

    @Override
    public List<class_1799> method_9560(class_2680 state, class_47.class_48 builder) {
        class_2371<class_1799> drops = class_2371.method_10211();
        builder.method_312(class_181.field_1224, state);
        class_2586 be = builder.method_308(class_181.field_1228);

        class_47 lootContext;
        lootContext = builder.method_309(class_173.field_1172);

        if (be instanceof MultipartBlockEntity) {
            MultipartBlockEntity mpbe = (MultipartBlockEntity) be;

            ItemDropTarget target = new ItemDropCollector(drops);

            for (PartHolder holder : mpbe.container.parts) {
                holder.part.addDrops(target, lootContext);
            }
        }
        return drops;
    }

    @Override
    @Environment(EnvType.CLIENT)
    public boolean playHitSound(
        class_1937 world, class_2338 pos, class_2680 state, class_1657 player, TransientPartIdentifier subpart
    ) {
        if (subpart.extra instanceof IdSubPart<?>) {
            playSubpartHitSound(player, (IdSubPart<?>) subpart.extra);
        } else {
            subpart.part.playHitSound(player);
        }
        return true;
    }

    private static <T> void playSubpartHitSound(class_1657 player, IdSubPart<T> subpart) {
        subpart.part.playHitSound(player, subpart.subpart);
    }

    @Deprecated
    @Override
    public TransientPartIdentifier getTargetedMultipart(class_2680 state, class_1937 world, class_2338 pos, class_243 vec) {
        return getMultipartTarget(state, world, pos, vec);
    }

    @Override
    public TransientPartIdentifier getMultipartTarget(class_2680 state, class_1922 view, class_2338 pos, class_243 vec) {
        class_2586 be = view.method_8321(pos);
        if (be instanceof MultipartBlockEntity) {
            MultipartBlockEntity multi = (MultipartBlockEntity) be;

            vec = vec.method_1020(class_243.method_24954(pos));

            for (PartHolder holder : multi.container.parts) {

                AbstractPart part = holder.getPart();

                if (part instanceof SubdividedPart<?>) {
                    TransientPartIdentifier id = getTargetSubPart((SubdividedPart<?>) part, vec);
                    if (id != null) {
                        return id;
                    }
                }

                if (doesContain(part, vec)) {
                    return new TransientPartIdentifier(part);
                }
            }
        }

        return null;
    }

    static boolean doesContain(AbstractPart part, class_243 vec) {
        class_265 shape = part.getOutlineShape();
        for (class_238 box : shape.method_1090()) {
            if (box.method_1014(0.01).method_1006(vec)) {
                return true;
            }
        }
        return false;
    }

    @Nullable
    private static <Sub> TransientPartIdentifier getTargetSubPart(SubdividedPart<Sub> part, class_243 vec) {
        Sub subpart = part.getTargetedSubpart(vec);
        if (subpart != null) {
            return new TransientPartIdentifier(part, subpart);
        }
        return null;
    }

    @Nullable
    @Override
    public TransientPartIdentifier getMultipartColliding(class_2680 state, class_1922 view, class_2338 pos,
                                                         class_238 toCollideWith, double clearance) {
        class_2586 be = view.method_8321(pos);
        if (be instanceof MultipartBlockEntity) {
            MultipartBlockEntity multi = (MultipartBlockEntity) be;

            toCollideWith = toCollideWith.method_997(class_243.method_24954(pos).method_22882()).method_1014(clearance);

            for (PartHolder holder : multi.container.parts) {

                AbstractPart part = holder.getPart();

                // Presumably, sub-part collision shapes should be part of the parent-part collision shape

                if (isCollidingWith(part, toCollideWith)) {
                    return new TransientPartIdentifier(part);
                }
            }
        }

        return null;
    }

    static boolean isCollidingWith(AbstractPart part, class_238 toCollideWith) {
        class_265 shape = part.getCollisionShape();
        for (class_238 box : shape.method_1090()) {
            if (box.method_994(toCollideWith)) {
                return true;
            }
        }
        return false;
    }

    @Override
    @Deprecated
    public class_265 getPartOutlineShape(class_2680 state, class_1937 world, class_2338 pos, class_243 hitVec) {
        return getPartOutline(state, world, pos, hitVec);
    }

    @Override
    public class_265 getPartOutline(class_2680 state, class_1922 world, class_2338 pos, class_243 hitVec) {
        TransientPartIdentifier target = getMultipartTarget(state, world, pos, hitVec);
        if (target == null) {
            return class_259.method_1073();
        }
        float partialTicks = LibMultiPart.partialTickGetter.getAsFloat();
        if (target.extra instanceof IdSubPart<?>) {
            class_265 sub = getSubpartShape((IdSubPart<?>) target.extra, hitVec, partialTicks);
            if (sub != null) {
                return sub;
            }
        }
        return target.part.getDynamicShape(partialTicks, hitVec);
    }

    @Nullable
    private static <S> class_265 getSubpartShape(IdSubPart<S> sub, class_243 vec, float partialTicks) {
        return sub.part.getSubpartDynamicShape(vec, sub.subpart, partialTicks);
    }
}
