/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.mixin.impl;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import alexiil.mc.lib.multipart.mixin.api.IBlockDynamicCull;
import net.minecraft.class_1922;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_247;
import net.minecraft.class_259;
import net.minecraft.class_265;
import net.minecraft.class_2680;

@Mixin(class_2248.class)
public class Client_BlockMixin {

    @Inject(
        method = "Lnet/minecraft/block/Block;shouldDrawSide(Lnet/minecraft/block/BlockState;Lnet/minecraft/world/BlockView;Lnet/minecraft/util/math/BlockPos;"
            + "Lnet/minecraft/util/math/Direction;Lnet/minecraft/util/math/BlockPos;)Z",
        cancellable = true,
        at = @At(value = "INVOKE", target = "Lnet/minecraft/block/BlockState;isOpaque()Z")
    )
    private static void shouldDrawSide(
        class_2680 state, class_1922 view, class_2338 pos, class_2350 facing, class_2338 offset, CallbackInfoReturnable<Boolean> ci
    ) {
        class_2680 oState = view.method_8320(offset);
        class_2248 block = state.method_26204();
        class_2248 oBlock = oState.method_26204();
        if (
            (block instanceof IBlockDynamicCull && ((IBlockDynamicCull) block).hasDynamicCull(state))
                || (oBlock instanceof IBlockDynamicCull && ((IBlockDynamicCull) oBlock).hasDynamicCull(oState))
        ) {
            class_265 voxelShape = state.method_26173(view, pos, facing);
            class_265 voxelShape2 = oState.method_26173(view, offset, facing.method_10153());
            ci.setReturnValue(class_259.method_1074(voxelShape, voxelShape2, class_247.field_16886));
        }
    }
}
