/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.mixin.impl;

import alexiil.mc.lib.multipart.mixin.api.IBlockCustomParticles;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import java.util.Random;
import net.minecraft.class_1297;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3532;

@Mixin(class_1297.class)
public abstract class Client_EntityMixin {

    @Shadow
    public class_1937 world;

    @Shadow
    public abstract double getX();

    @Shadow
    public abstract double getY();

    @Shadow
    public abstract double getZ();

    @Shadow
    @Final
    protected Random random;

    @Inject(at = @At("HEAD"), method = "spawnSprintingParticles()V", cancellable = true)
    private void spawnSprintingParticles(CallbackInfo ci) {
        // The associated Entity method seems to be called on both the client and the server, but the call to
        // `world.addParticle()` only does anything on the client.
        if (world.field_9236) {
            class_2338 blockPos = new class_2338(getX(), class_3532.method_15357(getY() - 0.2), class_3532.method_15357(getZ()));
            class_2680 state = world.method_8320(blockPos);
            class_2248 block = state.method_26204();
            if (block instanceof IBlockCustomParticles) {
                if (((IBlockCustomParticles) block).spawnSprintingParticles(world, blockPos, state,
                        (class_1297) (Object) this,
                        random)) {
                    ci.cancel();
                }
            }
        }
    }
}
