/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.mixin.impl;

import alexiil.mc.lib.multipart.mixin.api.IBlockCustomParticles;
import net.minecraft.class_1299;
import net.minecraft.class_1427;
import net.minecraft.class_1439;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3532;
import net.minecraft.class_5354;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_1439.class)
public abstract class Client_IronGolemEntityMixin extends class_1427 implements class_5354 {

    protected Client_IronGolemEntityMixin(class_1299<? extends class_1427> entityType, class_1937 world) {
        super(entityType, world);
    }

    @Inject(at = @At(value = "INVOKE",
            target = "Lnet/minecraft/world/World;addParticle(Lnet/minecraft/particle/ParticleEffect;DDDDDD)V"),
            method = "tickMovement()V", cancellable = true)
    private void tickMovment(CallbackInfo ci) {
        // The associated IronGolemEntity method seems to be called on both the client and the server, but the call to
        // `world.addParticle()` only does anything on the client.
        if (field_6002.field_9236) {
            class_2338 pos =
                    new class_2338(class_3532.method_15357(method_23317()), class_3532.method_15357(method_23318() - 0.2), class_3532.method_15357(method_23321()));
            class_2680 state = field_6002.method_8320(pos);
            class_2248 block = state.method_26204();
            if (block instanceof IBlockCustomParticles) {
                if (((IBlockCustomParticles) block).spawnIronGolemParticles(field_6002, pos, state,
                        (class_1439) (Object) this, method_6051())) {
                    ci.cancel();
                }
            }
        }
    }
}
