/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.multipart.mixin.impl;

import alexiil.mc.lib.multipart.mixin.api.IBlockCustomParticles;
import net.minecraft.class_1297;
import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_3532;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_1309.class)
public abstract class LivingEntityMixin extends class_1297 {

    public LivingEntityMixin(class_1299<?> type, class_1937 world) {
        super(type, world);
    }

    @Inject(at = @At(value = "INVOKE",
            target = "Lnet/minecraft/server/world/ServerWorld;spawnParticles(Lnet/minecraft/particle/ParticleEffect;DDDIDDDD)I"),
            method = "fall(DZLnet/minecraft/block/BlockState;Lnet/minecraft/util/math/BlockPos;)V", cancellable = true)
    private void fall(double heightDifference, boolean onGround, class_2680 landedState, class_2338 landedPosition,
                      CallbackInfo ci) {
        class_2338 blockPos = new class_2338(method_23317(), class_3532.method_15357(method_23318() - 0.2), class_3532.method_15357(method_23321()));
        class_2680 state = field_6002.method_8320(blockPos);
        class_2248 block = state.method_26204();
        if (block instanceof IBlockCustomParticles) {
            // This injector injects into an if statement that checks `!world.isClient`
            if (((IBlockCustomParticles) block).spawnFallParticles((class_3218) field_6002, blockPos, state,
                    (class_1309) (Object) this, field_5974)) {
                ci.cancel();

                // Since we're canceling, the rest of this method won't run. We should do the things that would normally
                // come after.
                super.method_5623(heightDifference, onGround, landedState, landedPosition);
            }
        }
    }
}
